bbc.fmtj.utils.createObject('bbc.fmtj.apps.election2010.page');
gloader.load(['glow', '1.7', 'glow.dom', 'glow.events', 'glow.net', 'glow.widgets.AutoSuggest', 'glow.widgets.InfoPanel'],{
	async: false,
	onLoad: function(glow) {
		glow.ready(function() {
			bbc.fmtj.apps.election2010.page = (function() {
				var listErrorPanel,
					pub = {				
						init: init,
						loadPostCodeSearch: loadPostCodeSearch,
						loadSearchData: loadSearchData
					};
				return pub;
				
				function init() {
					// handle form submits, it doesn't bubble so put it on these elements.					
					glow.events.addListener('#constituency-search-form', 'submit', function(e) {
						e.preventDefault();
						var searchText = glow.dom.get(this).get('#constituency-search').val();
						if(/\d/.test(searchText)) {
							// do a postcode search
							glow.net.loadScript('http://www.bbc.co.uk/cgi-perl/whereilive/server/bouncer_api.pl?type=news_election_json&loc=' + searchText);						
						} else {
							glow.net.loadScript('http://search.bbc.co.uk/suggest?q='+searchText+'&scope=constituencies&format=constituencies&callback=bbc.fmtj.apps.election2010.page.loadSearchData');
						}
					});
				}
				
				function loadPostCodeSearch(res) {
					if(res && res.error) {
						res.error = res.error.replace('<p/>', '<br />')
						if(listErrorPanel) {
							listErrorPanel.hide();
						}
						listErrorPanel = new glow.widgets.InfoPanel(
							glow.dom.create('<div id="constituency-error">'+res.error+'</div>'),
							{
								context: '#constituency-search',
								pointerPosition: "t",
								offsetInContext: {x: "60%", y: "72%"},
								width: 220,
								theme: 'light', 
								closeOnEsc: true,
								hideWindowedFlash: false
							}
						);
						listErrorPanel.show();
					} else {
						setTimeout(function() { window.location.assign('http://news.bbc.co.uk/nol/shared/election2010/results/constituency/' + res.postId + '.stm'); }, 10);
					}
				}
				
				function loadSearchData(res) {
					if(res && res.error) {
						if(listErrorPanel) {
							listErrorPanel.hide();
						}
						listErrorPanel = new glow.widgets.InfoPanel(
							glow.dom.create('<div id="constituency-error"><p>There are no results for the name you have entered.</p><p>Try again or try entering your full postcode.</p></div>'),
							{
								context: '#constituency-search', 
								pointerPosition: "t",
								offsetInContext: {x: "60%", y: "72%"},
								width: 220,
								theme: 'light',
								closeOnEsc: true,
								hideWindowedFlash: false
							}
						);
						listErrorPanel.show();
					} else if(res && res.length) {
						if(res.length > 1) {
							var items = '', i;
							for(i in res) {
								items += '<li><a href="/nol/shared/election2010/results/constituency/' + res[i].postId + '.stm">' + res[i].name + '</a></li>';
							}
						
							// show multiple options
							if(listErrorPanel) {
								listErrorPanel.hide();
							}
							listErrorPanel = new glow.widgets.InfoPanel(
								glow.dom.create('<div id="constituency-options"><ol>'+items+'</ol></div>'),
								{
									context: '#constituency-search',
									pointerPosition: "t",
									offsetInContext: {x: "60%", y: "72%"},
									width: 220,
									theme: 'light',
									closeOnEsc: true,
									hideWindowedFlash: false
								}
							);
							listErrorPanel.show();
						} else {
							// redirect
							setTimeout(function() { window.location.assign('/nol/shared/election2010/results/constituency/' + res[0].postId + '.stm'); }, 10);
						}
					}
				}
			}());
			bbc.fmtj.apps.election2010.page.init();
		});
	}
});